//*************************************************
//
// main.c
// esempio di memorizzazione valori in eeprom esterna
// I2C
// autore: Bernardo Giovanni (www.settorezero.com)
// data: 31/08/2010
//
//*************************************************

#define  XTAL_FREQ 20MHZ
#include <pic.h>

__CONFIG (HS & WDTDIS & PWRTEN & BORDIS & LVPDIS & DUNPROT & WRTEN & DEBUGDIS & UNPROTECT);

#include "delay.c" 
#include "i2c.c" 
#include "eeprom_external.c" 
 
void main(void) 
	{ 
	ADCON0 = 0x00; // Disabilita A/D convertitore 
	ADCON1 = 0x07; // Configura PortA come digitale 
	PORTA = 0x00; // Reset ogni linea 
	PORTB = 0x00; // Reset ogni linea 
	PORTC = 0x00; // Reset ogni linea 
	PORTD = 0x00; // Reset ogni linea 
	PORTE = 0x00; // Reset ogni linea 
	TRISA = 0x00; // Tutte le porte definite come output 
	TRISB = 0x00; // Tutte le porte definite come output 
	TRISC = 0x00; // Tutte le porte definite come output 
	TRISD = 0x00; // Tutte le porte definite come output 
	TRISE = 0x00; // Tutte le porte definite come output 

	I2cInitMaster(); // avvio il modulo MSSP in modalit I2C master

	unsigned char deviceid = 0x00; // Indirizzo della eeprom esterna
	unsigned char data1 = 0x0F; // Valore da scrivere nella eeprom 
	unsigned char data2 = 0xF0; // Valore da scrivere nella eeprom 

	// scrivo il dato data1 (0x0F) nella cella 0x00 della memoria eeprom
	// che si trova all'indirizzo 0x00
	eee_write_byte(deviceid, 0x00, data1);
	data1 = 0x00; // azzero il dato appena scritto
	
	DelayMs(5); // ogni byte ci mette circa 5mS per essere scritto
	// quindi per leggerlo devo attendere questo tempo
	
	data1 = eee_read_byte(deviceid, 0x00); // leggo il valore contenuto nella cella 0
	PORTD = data1; // visualizzo sui led il valore appena letto
	
	DelayMs(250);  
	DelayMs(250);  
	DelayMs(250);  
	DelayMs(250);  
	
	PORTD=0; // spengo i led

	// scrivo il dato data2 (0xF0) nella cella 0x01 della memoria eeprom
	eee_write_byte(deviceid, 0x01, data2);
	data2 = 0x00; // azzero il dato appena scritto
	
	DelayMs(5); 
	
	data2 = eee_read_byte(deviceid, 0x01); // leggo il valore contenuto nella cella 1
	
	PORTD = data2; // visualizzo sui led il valore appena letto

	while(1)
		{}
	}
